define( function() {
"use strict";

function C_Control()
{
};

C_Control.prototype.draw = function( oControlHost )
{  
	this.m_oControlHost = oControlHost;
	var oConfig = oControlHost.configuration || {};
	this.m_sParameter = oConfig["Parameter name"] || "pl";
	var oParameter = oControlHost.getParameter( this.m_sParameter );
	var oParameterValues = new Set();
	if ( oParameter && ( oParameter.values.length > 0 ) )
	{
		oParameter.values.forEach( function( o ) { this.add( o.use ); }, oParameterValues );
	}

	var el = oControlHost.container;
	var sID = '#' + el.id + ' ';
	var sHtml =
		'<style>' +
		sID + 'BUTTON' +
		'{' +
			'position: relative;' +
			'display: flex;' +
			'margin-left: 0;' +
			'padding-left: 16px;' +
			'padding-right: 8px;' +
			'padding-top: 4px;' +
		'}' +
		sID + 'BUTTON > DIV' +
		'{' +
			'position: absolute;' +
			'z-index: 1;' +
			'display: none;' +
			'top: calc(100% + 1px);' +
			'left: -2px;' +
			'text-align: left;' +
			'background-color: white;' +
			'border: 1px solid #C0BFC0;' +
			'padding: 8px;' +
			'font-weight: normal;' +
		'}' +
		sID + 'BUTTON:hover > DIV' +
		'{' +
			'display: block;' +
		'}' +
		sID + 'BUTTON > svg' +
		'{' +
			'height: 16px;' +
			'width: 16px;' +
			'display: inline-block;' +
			'margin-left:16px;' +
			'transition-duration: 0.3s;' +
			'transition-timing-function: ease-out;' +
			'transition-property: transform;' +
		'}' +
		sID + 'BUTTON:hover > svg' +
		'{' +
			'transform: rotate(90deg);' +
		'}' +
		'</style>';
	sHtml += '<button class="clsDlgButton">';
    var iRowCount = this.m_oDataStore.rowCount;

	var bMultiSelect = ( oConfig.MultiSelect !== false );
	var bSuppressSelection = false;
	var sClass = bMultiSelect ? "clsCheckbox" : "clsRadioButton";
	var sType = bMultiSelect ? "checkbox" : "radio";
	var sName = bMultiSelect ? "" : ( ' name="' + ( el.id + "__radio__" ) + '"' );
	var iScrollIfMoreThan = 8;
	sHtml += '<div' + ( ( iRowCount > iScrollIfMoreThan ) ? ( ' style="overflow-y:auto; height:' + ( iScrollIfMoreThan * 32 ) + 'px"' ) : '' ) + '>';
	for ( var iRow = 0; iRow < iRowCount; iRow++ )
	{
		var sValue = this.m_oDataStore.getCellValue( iRow, 0 );
		var bSelected = !bSuppressSelection && oParameterValues.has( sValue );
		if ( bSelected && !bMultiSelect )
		{
			bSuppressSelection = true;
		}
		sHtml += '<label class="' + sClass + '" style="' + ( ( iRow > 0 ) ? 'margin-top:16px;' : '' ) + '">';
		sHtml += '<input type="' + sType + '" ' + ( bSelected ? ' checked="true"' : '' ) + sName + '/> <span>' + sValue + '</span></label>';
	}

//	sHtml += '<div>Clear all</div>';

	var sLabel = oConfig.Label || this.m_oDataStore.columnNames[0];
	sHtml += '</div><span>' + sLabel + '</span><svg viewBox="0 0 16 16"><path d="M5 12.5L9.2 8 5 3.5 6.4 2 12 8l-5.6 6L5 12.5z"/></svg></button>';
	el.innerHTML = sHtml;
    el.onclick = this.f_onChange.bind( this, oControlHost, oConfig.AutoSubmit );
};

C_Control.prototype.f_onChange = function( oControlHost, bAutoSubmit )
{
	oControlHost.valueChanged();
	if ( bAutoSubmit )
	{
		oControlHost.next();
	}
};

C_Control.prototype.setData = function( oControlHost, oDataStore )
{
	this.m_oDataStore = oDataStore;
};

C_Control.prototype.getParameters = function()
{
	var v_aValues = [];
	var nl = this.m_oControlHost.container.querySelectorAll( "input" );
	for ( var i = 0; i < nl.length; i++ )
	{
		var elInput = nl.item( i );
		if ( elInput.checked )
		{
			v_aValues.push( { "use" : elInput.parentNode.querySelector( "SPAN" ).textContent } );
		}
	}
	return [{
		"parameter": this.m_sParameter,
		"values": v_aValues
	}];
};

C_Control.prototype.isInValidState = function()
{
	return true;
};

return C_Control;
});
